Subject: [secdir] secdir review of draft-templin-aero-10

From: Joe Salowey <[email-masked]>
Date: Sun, 22 Apr 2012 15:00:07 -0700

I have reviewed this document as part of the security directorate's 
ongoing effort to review all IETF documents being processed by the 
IESG.  These comments were written primarily for the benefit of the 
security area directors.  Document editors and WG chairs should treat 
these comments just like any other last call comments.

I apologize for the delay in getting this review out.  Hopefully it is still useful.  

This first set of comments is primarily for the authors.

1. In section 4.4.4 on Data origin authentication the last paragraph states that only the 3rd of the above conditions is acceptable, do you really mean the 4th?
2. In section 4.4.4 there is reference to the packet including a digital signature to authenticate the origin.  What is the signature mechanism?  Is this SEND or something different? I did not see a reference to it.
3. The security considerations do not say much about the consequences of trusting an inappropriate intermediate router, ingress node or egress node. Clearly DOS to the ingress node is a possibility.   Data modification and disclosure can be a goal of an attacker who tries to control the routing.   Are there other issues the reader should be aware of (perhaps other DOS attacks such as amplification attacks).  Anything outside the considerations of RFC4861)?
4. The security consideration section indicates that spoofing protection can be provided by links that provide link layer security mechanisms.    Link Layer security mechanisms may or may not help.   I believe more information is needed here.  L2 mechanisms may not provide adequate protection of upper layer address bindings.  In some cases L2 mechanisms do not provide source origin authentication such as multicast  traffic protected with the group  key in WiFi and group security associations in 802.1AE (MACSEC). 

This set of comments is mostly for the area directors:

1. I am mostly concerned about the lack of definition for the digital signature mechanism.  Perhaps this is easily rectified by a reference to an existing specification. Its not clear to me what the specification would be (perhaps SEND??)?  Is something needed in addition? 
2.  The risks of not securing the proposal are not defined in the security considerations section. I think this would be helpful, but may not be strictly necessary.  There is some mention of Link-Layer security helping in some aspects of this, but its not clear on what characteristics the lower layer security needs to provide. 

Cheers,

Joe

---

From: Fred Templin <[email-masked]>
Date: Mon, 23 Apr 2012 09:31:07 -0700 (PDT)

Hello Joe,

Thank you for these comments. Please see attached for my proposed
resolutions:

Fred
[email-masked]

>________________________________
> From: Joe Salowey <[email-masked]>
>To: [email-masked]; The IESG <[email-masked]>; [email-masked] 
>Sent: Sunday, April 22, 2012 3:00 PM
>Subject: secdir review of draft-templin-aero-10
>

---

From: Fred Templin <[email-masked]>
Date: Mon, 23 Apr 2012 09:52:36 -0700 (PDT)

(Resending with comments as inline text)

Hello Joe,

Thank you for these comments. Please see below for my proposed
resolutions:

Fred
[email-masked]

>>>> Begin FLT response
>You are correct; this should say the 4th and
can be fixed in the next version.>>> End FLT response
>>>> Begin FLT response
>The digital signature mechanism is out of scope for
this document. The text
>could be adjusted to say: “…, AERO nodes may be obliged
to require the
>use of digital signatures applied through means outside the
scope of this
>document.”>>> End FLT response
>
>>>> Begin FLT response
>Proposed resolution is to re-write the first paragraph
of Section 6 as follows:
> 
>“AERO link security considerations are the same as for standard
IPv6 Neighbor Discovery
>(RFC4861) except that AERO improves on some aspects. In
particular, AERO is dependent
>on a trust basis between AERO edge nodes and intermediate
routers, where the edge nodes
>must only engage in the AERO mechanism when it is
facilitated by a trusted intermediate
>router.”>>> End FLT response
>
>>>> Begin FLT response
>Proposed resolution is to re-write the second paragraph
of Section 6 as follows:
>“AERO links must be protected against spoofing attacks in which an attacker
>on the link pretends to be a trusted neighbor.  Links that provide link-layer
>securing mechanisms (e.g., WiFi networks) and links that provide physical
>security (e.g., enterprise network LANs) provide only a fist-line of defense.In some instances, therefore, additional
securing assurances against on-link
>spoofing attacks are required. For example,
if the source can through some
>means digitally sign its messages the
destination can verify the signatures to
>ensure data origin authentication.
Exact mechanisms for digitally signing and
>verifying signatures are outside the
scope of this document.”
>>>> End FLT response

---

From: Joe Salowey <[email-masked]>
Date: Tue, 24 Apr 2012 10:47:49 -0700

Thanks for the quick response, comments inline:
On Apr 23, 2012, at 9:52 AM, Fred Templin wrote:

> You are correct; this should say the 4th and can be fixed in the next version.
> >>> End FLT response
> 

[Joe] OK

> The digital signature mechanism is out of scope for this document. The text
> could be adjusted to say: “…, AERO nodes may be obliged to require the
> use of digital signatures applied through means outside the scope of this
> document.”
> >>> End FLT response
> 

[Joe] I was hoping that something would be specified for interoperability,  I think there are many cases where you would have to resort to a signing mechanism, however it may be the case that AERO may be deployed where spoofing of messages is not a concern (perhaps this should be the recommendation until a signing mechanism is specified).  The ADs can decide if this is an issue or not. 

> Proposed resolution is to re-write the first paragraph of Section 6 as follows:
>  
> “AERO link security considerations are the same as for standard IPv6 Neighbor Discovery
> (RFC4861) except that AERO improves on some aspects. In particular, AERO is dependent
> on a trust basis between AERO edge nodes and intermediate routers, where the edge nodes
> must only engage in the AERO mechanism when it is facilitated by a trusted intermediate
> router.”
> >>> End FLT response
> 

[Joe] OK thanks.

> Proposed resolution is to re-write the second paragraph of Section 6 as follows:
> security (e.g., enterprise network LANs) provide only a fist-line of defense.
> In some instances, therefore, additional securing assurances against on-link
> spoofing attacks are required. For example, if the source can through some
> means digitally sign its messages the destination can verify the signatures to
> ensure data origin authentication. Exact mechanisms for digitally signing and
> verifying signatures are outside the scope of this document.”
> >>> End FLT response
> 
[Joe] Thanks. (same comment on the specification of the signing mechanism as above).

---

From: Fred Templin <[email-masked]>
Date: Tue, 24 Apr 2012 11:14:36 -0700 (PDT)

Hello Joe,

Thank you for your comments. To your question on specifying a digital
signing mechanism, would the concern be addressed if I were to say
something like: "e.g., using IPsec AH, etc." ?

Fred
[email-masked]

----- Original Message -----
> To: Fred Templin <[email-masked]>
> Cc: "[email-masked]" <[email-masked]>; The IESG <[email-masked]>; "[email-masked]" <[email-masked]>
> Sent: Tuesday, April 24, 2012 10:47 AM
> Subject: Re: secdir review of draft-templin-aero-10
> 
>T hanks for the quick response, comments inline:
>>  1. In section 4.4.4 on Data origin authentication the last paragraph states 
> that only the 3rd of the above conditions is acceptable, do you really mean the 
> 4th?
>> 
>>  >>> Begin FLT response
>>  2. In section 4.4.4 there is reference to the packet including a digital 
> signature to authenticate the origin.  What is the signature mechanism?  Is this 
> SEND or something different? I did not see a reference to it.
>> 
>>  >>> Begin FLT response
> [Joe] I was hoping that something would be specified for interoperability,  I 
> think there are many cases where you would have to resort to a signing 
> mechanism, however it may be the case that AERO may be deployed where spoofing 
> of messages is not a concern (perhaps this should be the recommendation until a 
> signing mechanism is specified).  The ADs can decide if this is an issue or not.
>
>>  3. The security considerations do not say much about the consequences of 
> trusting an inappropriate intermediate router, ingress node or egress node. 
> Clearly DOS to the ingress node is a possibility.  Data modification and 
> disclosure can be a goal of an attacker who tries to control the routing.  Are 
> there other issues the reader should be aware of (perhaps other DOS attacks such 
> as amplification attacks).  Anything outside the considerations of RFC4861)?
>> 
>>  >>> Begin FLT response
>>  4. The security consideration section indicates that spoofing protection 
> can be provided by links that provide link layer security mechanisms.    Link 
> Layer security mechanisms may or may not help.  I believe more information is 
> needed here.  L2 mechanisms may not provide adequate protection of upper layer 
> address bindings.  In some cases L2 mechanisms do not provide source origin 
> authentication such as multicast  traffic protected with the group  key in WiFi 
> and group security associations in 802.1AE (MACSEC).
>> 
>>  >>> Begin FLT response
>>  1. I am mostly concerned about the lack of definition for the digital 
> signature mechanism.  Perhaps this is easily rectified by a reference to an 
> existing specification. Its not clear to me what the specification would be 
> (perhaps SEND??)?  Is something needed in addition? 
>>  2.  The risks of not securing the proposal are not defined in the security 
> considerations section. I think this would be helpful, but may not be strictly 
> necessary.  There is some mention of Link-Layer security helping in some aspects 
> of this, but its not clear on what characteristics the lower layer security 
> needs to provide. 
>> 
>>  Cheers,
>> 
>>  Joe
>> 
>

---

From: Joe Salowey <[email-masked]>
Date: Tue, 24 Apr 2012 15:55:35 -0700

> something like: "e.g., using IPsec AH, etc." ?
[Joe] Not really.  What I'm looking for is something that specifies the mechanism and how its used.  Something like 

"Implementations MUST support <IPSEC AH> as a means to authenticate the origin of the AERO messages.  AERO peers MUST support establishing an <IPSEC SA> using <IKEv2> with <certificates> as specified in <external reference>.   During <SA> establishment AERO hosts MUST be able identify AERO intermediate routers through mechanism defined in <RFCxxxx or section y.yy>.  "

The stuff in the <> should be replaced with something that makes sense.  I'm not sure that IPSEC AH or any of the other things in <> are really appropriate in this case.  The idea here is that there is some minimum mechanism that implementations can use to secure these messages. Securing the messages involves the transform for authenticating the messages (perhaps IPSEC AH), mechanism for key management perhaps (IKV2 with certificates) and a way to establish that you are taking to the right router (perhaps be able to match a field in a certificate to a particular name or domain).   My hope is that there already is something that would fit the bill and we could just reference that specification.  Some of the SEND variants may be useful in this scenario,  but I didn't get a chance to dig into this.  

Joe

---

From: Sean Turner <[email-masked]>
Date: Wed, 25 Apr 2012 15:12:13 -0400

On 4/24/12 6:55 PM, Joe Salowey wrote:
> "Implementations MUST support<IPSEC AH>  as a means to authenticate the origin of the AERO messages.  AERO peers MUST support establishing an<IPSEC SA>  using<IKEv2>  with<certificates>  as specified in<external reference>.   During<SA>  establishment AERO hosts MUST be able identify AERO intermediate routers through mechanism defined in<RFCxxxx or section y.yy>.  "
>
> The stuff in the<>  should be replaced with something that makes sense.  I'm not sure that IPSEC AH or any of the other things in<>  are really appropriate in this case.  The idea here is that there is some minimum mechanism that implementations can use to secure these messages. Securing the messages involves the transform for authenticating the messages (perhaps IPSEC AH), mechanism for key management perhaps (IKV2 with certificates) and a way to establish that you are taking to the right router (perhaps be able to match a field in a certificate to a particular name or domain).   My hope is that there already is something that would fit the bill and we could just reference that specification.  Some of the SEND variants may be useful in this scenario,  but I didn't get a chance to dig into this.

Fred,

Note that every so often somebody tries to deprecate AH because very few 
folks use it.

spt

>>> From: Joe Salowey<[email-masked]>
>>> To: Fred Templin<[email-masked]>
>>> Cc: "[email-masked]"<[email-masked]>; The IESG<[email-masked]>; "[email-masked]"<[email-masked]>
>>>> From: Joe Salowey<[email-masked]>
>>>> To: [email-masked]; The IESG<[email-masked]>;
>>> [email-masked]
> _______________________________________________
> secdir mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/secdir
> wiki: http://tools.ietf.org/area/sec/trac/wiki/SecDirReview
>

---

From: "Fred L. Templin" <[email-masked]>
Date: Tue, 24 Apr 2012 16:16:21 -0700 (PDT)

Hi Joe,

>Sent: Tuesday, April 24, 2012 3:55 PM

Your text looks good, but I really don't want to exclusively wrap this
around IPsec AH - ultimately, I would like to have something much
lighter-weight, but its design is still pending. As this is going for
experimental, part of the experiment should be to investigate alternatives
and bring forth the best option or options in a follow-on standards-track
effort. And it is also not at all the case that all AERO use cases would
require a digital signing mechanism - I have several in mind that do not.

>The stuff in the <> should be replaced with something that makes sense.  I'm not sure that IPSEC AH or any of the other things in <> are really appropriate in this case.  The idea here is that there…

I would be happy to hear about alternatives that would satisfy the need,
but I don't think it would be based on SEND since signatures would be
required on all packets and not just ND messages. Or, perhaps you have
heard of SEND variants that extend to cover data packets as well as ND?

Thanks - Fred
[email-masked]

---

From: "Fred L. Templin" <[email-masked]>
Date: Wed, 25 Apr 2012 18:51:56 -0700 (PDT)

Hi Sean,

Thanks for your point about occasional attempts to deprecate IPsec AH. What
I have in mind for AERO is something sort of like IPsec AH but much lighter
weight. I have the design worked out in my head and could use some input
from others, but is this the correct forum to kick ideas around?

Fred
[email-masked]

> From: Sean Turner <[email-masked]>
>Cc: Joe Salowey <[email-masked]>; "[email-masked]" <[email-masked]>; The IESG <[email-masked]>; "[email-masked]" <[email-masked]> 
>Sent: Wednesday, April 25, 2012 12:12 PM
>Subject: Re: [secdir] secdir review of draft-templin-aero-10
>